---
title: 'ARIA: img role'
slug: Web/Accessibility/ARIA/Roles/Role_Img
tags:
  - ARIA
  - ARIA Img
  - ARIA Role
  - Accessibility
  - Reference
  - Rôle
  - figure
---
<div>{{Page("/en-US/docs/Web/Accessibility/ARIA/Roles", "Subnav")}}</div>

<p>The ARIA <code>img</code> role can be used to identify multiple elements inside page content that should be considered as a single image. These elements could be images, code snippets, text, emojis, or other content that can be combined to deliver information in a visual manner.</p>

<pre class="brush: html">&lt;div role="img" aria-label="Description of the overall image"&gt;
  &lt;img src="graphic1.png" alt=""&gt;
  &lt;img src="graphic2.png"&gt;
&lt;/div&gt;
</pre>

<h2 id="Description">Description</h2>

<p>Any set of content that should be consumed as a single image (which could include images, video, audio, code snippets, emojis, or other content) can be identified using <code>role="img"</code>.</p>

<p>You shouldn't count on the alt text of individual elements images for conveying context to assistive technologies; most screenreaders will consider the element with <code>role="img"</code> set on it to be to be like a black box, and not access the individual elements inside it.  Therefore, provide a comprehensive overall descriptive alt text for image, either in the surrounding text, or by using an <code>aria-label</code> attribute, with optional alt attributes for search engines or sighted users to be written to the page should an image fail:</p>

<pre class="brush: html">&lt;div role="img" aria-label="Description of the overall image"&gt;
  &lt;img src="graphic1.png" alt=""&gt;
  &lt;img src="graphic2.png"&gt;
&lt;/div&gt;</pre>

<p>If you wish to add a caption or label to your image that is visible on the page, you can do using:</p>

<ul>
 <li><code>aria-labelledby</code> when the text is a concise label.</li>
 <li><code>aria-describedby</code> when the text is a longer description.</li>
</ul>

<p>For example:</p>

<pre class="brush: html">&lt;div role="img" aria-labelledby="image-1"&gt;
  ...
  &lt;p id="image-1"&gt;Text that describes the group of images.&lt;/p&gt;
&lt;/div<strong>&gt;</strong></pre>

<h3 id="SVG_and_roleimg">SVG and role="img"</h3>

<p>If you are using embedded SVG images in your page, it is a good idea to set <code>role="img"</code> on the outer <code>&lt;svg&gt;</code> element and give it a label. This will cause screen readers to just consider it as a single entity and describe it using the label, rather than trying to read out all the child nodes:</p>

<pre class="brush: html">&lt;svg role="img" aria-label="Description of your SVG image"&gt;
  &lt;!-- contents of the SVG image --&gt;
&lt;/svg&gt;</pre>

<h3 id="Using_roleimg_to_confer_meaning_that_is_obscured_or_implied">Using role="img" to confer meaning that is obscured or implied</h3>

<p>In certain cases, assistive technology users won't be able to get the meaning of content expressed in certain ways, through certain media, or implied in certain ways. This is obvious to fix in the case of images (you can use the <code>alt</code> attribute), but in the case of mixed or other certain types of content it is not so obvious, and <code>role="img"</code> can come into play.</p>

<p>For example, if you use emojis in your text, the meaning might be obvious to a sighted user, but someone using a screenreader might get confused because the emojis might have either no text representation at all, or the alternative text might be confusing and not match the context it is being used in. For example, take the following code:</p>

<pre class="brush: html">&lt;div role="img" aria-label="That cat is so funny"&gt;
  &lt;p&gt;
    &amp;#x1F408; &amp;#x1F602;
  &lt;/p&gt;
&lt;/div&gt;</pre>

<p>&amp;#x1F408; &amp;#x1F602; are entity references for emojis read out as "Cat" and "Face with tears of joy", but this doesn't necessarily make sense — the implied meaning is possibly more like "That cat is so funny", so we include that in an <code>aria-label</code> along with <code>role="img"</code>.</p>

<p>This seems to work OK across some browser/screenreader combinations, but some of them end up reading the label out twice. Use with caution and test thoroughly.</p>

<p>Another example where this might be suitable is when using ASCII emoji combinations, like the legendary "Table flip":</p>

<pre class="brush: html">&lt;div role="img" aria-label="Table flip"&gt;
  &lt;p&gt;
    (╯°□°）╯︵ ┻━┻
  &lt;/p&gt;
&lt;/div&gt;</pre>

<h3 id="Associated_WAI-ARIA_Roles_States_and_Properties">Associated WAI-ARIA Roles, States, and Properties</h3>

<dl>
 <dt>aria-label</dt>
 <dd>An accessible name is required. An aria-label attribute</dd>
</dl>

<h3 id="Keyboard_Interactions">Keyboard Interactions</h3>

<h3 id="Required_JavaScript_features">Required JavaScript features</h3>

<h2 id="Examples">Examples</h2>

<ul>
 <li><a href="https://codepen.io/svinkle/pen/oYjoNE">star rating role="img" example</a></li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName("ARIA","#img","img")}}</td>
   <td>{{Spec2('ARIA')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Screen_reader_support">Screen reader support</h2>

<p>TBD</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://wicg.github.io/aom/spec/">Accessibility Object Model</a></li>
 <li><a href="https://w3c.github.io/html-aria/">ARIA in HTML</a></li>
</ul>
